diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc ns-3.38/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc
--- ns-3.37/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/buildings/test/three-gpp-v2v-channel-condition-model-test.cc	2023-03-16 20:54:23.584868400 -0700
@@ -68,15 +68,15 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         Vector m_positionA;                            //!< the position of the first node
         Vector m_positionB;                            //!< the position of the second node
         ChannelCondition::LosConditionValue m_losCond; //!< the correct channel condition
         TypeId m_typeId; //!< the type ID of the channel condition model to be used
-    } TestVector;
+    };
 
-    TestVectors<TestVector> m_testVectors; //!< array containg all the test vectors
+    TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
 };
 
 ThreeGppV2vBuildingsChCondModelTestCase::ThreeGppV2vBuildingsChCondModelTestCase()
@@ -221,13 +221,13 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         Vector m_positionA; //!< the position of the first node
         Vector m_positionB; //!< the position of the second node
         double m_pLos;      //!< LOS probability
         TypeId m_typeId;    //!< the type ID of the channel condition model to be used
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     Ptr<ThreeGppV2vUrbanChannelConditionModel> m_condModel; //!< the channel condition model
@@ -386,13 +386,13 @@
     /**
      * Struct containing the parameters for each test
      */
-    typedef struct
+    struct TestVector
     {
         Vector m_positionA; //!< the position of the first node
         Vector m_positionB; //!< the position of the second node
         double m_pLos;      //!< LOS probability
         TypeId m_typeId;    //!< the type ID of the channel condition model to be used
-    } TestVector;
+    };
 
     TestVectors<TestVector> m_testVectors; //!< array containing all the test vectors
     Ptr<ThreeGppV2vHighwayChannelConditionModel> m_condModel; //!< the channel condition model
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/click/CMakeLists.txt ns-3.38/src/click/CMakeLists.txt
--- ns-3.37/src/click/CMakeLists.txt	2022-11-01 17:37:24.459395000 -0700
+++ ns-3.38/src/click/CMakeLists.txt	2023-03-16 20:54:23.584868400 -0700
@@ -23,6 +23,8 @@
     click_FOUND)
    AND (NOT
         ${click_FOUND})
+   AND (NOT
+        ${NS3_FETCH_OPTIONAL_COMPONENTS})
 )
   message(
     ${HIGHLIGHTED_STATUS}
@@ -31,6 +33,13 @@
   return()
 endif()
 
+if(${NS3_FETCH_OPTIONAL_COMPONENTS})
+  set(click_LIBRARIES
+      click
+      nsclick
+  )
+endif()
+
 include_directories(${click_INCLUDE_DIRS})
 set(NS3_CLICK
     "ON"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/click/model/ipv4-click-routing.cc ns-3.38/src/click/model/ipv4-click-routing.cc
--- ns-3.37/src/click/model/ipv4-click-routing.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/click/model/ipv4-click-routing.cc	2023-03-16 20:54:23.584868400 -0700
@@ -29,6 +29,7 @@
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
 
+#include <click/simclick.h>
 #include <cstdarg>
 #include <cstdlib>
 #include <map>
@@ -817,7 +818,7 @@
         // Try to fill the buffer with up to size bytes.
         // If this is not enough space, write the required buffer size into
         // the size variable and return an error code.
-        // Otherwise return the bytes actually writte into the buffer in size.
+        // Otherwise return the bytes actually written into the buffer in size.
 
         // Append key/value pair, separated by \0.
         std::map<std::string, std::string> defines = clickInstance->GetDefines();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/click/model/ipv4-click-routing.h ns-3.38/src/click/model/ipv4-click-routing.h
--- ns-3.37/src/click/model/ipv4-click-routing.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/click/model/ipv4-click-routing.h	2023-03-16 20:54:23.584868400 -0700
@@ -26,19 +26,18 @@
 #include "ns3/packet.h"
 #include "ns3/test.h"
 
-#include <sys/time.h>
-#include <sys/types.h>
-
-#ifdef NS3_CLICK
-#include <click/simclick.h>
-#endif
-
 #include <map>
 #include <string>
+#include <sys/time.h>
+#include <sys/types.h>
 
 class ClickTrivialTest;
 class ClickIfidFromNameTest;
 class ClickIpMacAddressFromNameTest;
+// These are in #include <click/simclick.h>,
+// here we just need a forward declaration.
+struct simclick_node;
+typedef struct simclick_node simclick_node_t;
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/CMakeLists.txt ns-3.38/src/CMakeLists.txt
--- ns-3.37/src/CMakeLists.txt	2022-11-01 17:37:24.451395000 -0700
+++ ns-3.38/src/CMakeLists.txt	2023-03-16 20:54:23.572868300 -0700
@@ -87,3 +87,7 @@
     add_dependencies(timeTraceReport ${lib-ns3-monolib})
   endif()
 endif()
+
+if(${NS3_FETCH_OPTIONAL_COMPONENTS})
+  add_dependency_to_optional_modules_dependencies()
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/examples/config-store-save.cc ns-3.38/src/config-store/examples/config-store-save.cc
--- ns-3.37/src/config-store/examples/config-store-save.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/examples/config-store-save.cc	2023-03-16 20:54:23.584868400 -0700
@@ -113,4 +113,6 @@
     Simulator::Run();
 
     Simulator::Destroy();
+
+    return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/attribute-iterator.cc ns-3.38/src/config-store/model/attribute-iterator.cc
--- ns-3.37/src/config-store/model/attribute-iterator.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/attribute-iterator.cc	2023-03-16 20:54:23.584868400 -0700
@@ -73,7 +73,7 @@
     {
         oss << "/" << m_currentPath[i];
     }
-    if (attr != "")
+    if (!attr.empty())
     {
         oss << "/" << attr;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/config-store.cc ns-3.38/src/config-store/model/config-store.cc
--- ns-3.37/src/config-store/model/config-store.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/config-store.cc	2023-03-16 20:54:23.584868400 -0700
@@ -154,14 +154,14 @@
 }
 
 void
-ConfigStore::SetMode(enum Mode mode)
+ConfigStore::SetMode(Mode mode)
 {
     NS_LOG_FUNCTION(this << mode);
     m_mode = mode;
 }
 
 void
-ConfigStore::SetFileFormat(enum FileFormat format)
+ConfigStore::SetFileFormat(FileFormat format)
 {
     NS_LOG_FUNCTION(this << format);
     m_fileFormat = format;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/config-store.h ns-3.38/src/config-store/model/config-store.h
--- ns-3.37/src/config-store/model/config-store.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/config-store.h	2023-03-16 20:54:23.584868400 -0700
@@ -96,12 +96,12 @@
      * Set the mode of operation
      * \param mode mode of operation
      */
-    void SetMode(enum Mode mode);
+    void SetMode(Mode mode);
     /**
      * Set the file format
      * \param format the file format
      */
-    void SetFileFormat(enum FileFormat format);
+    void SetFileFormat(FileFormat format);
     /**
      * Set the filename
      * \param filename the file name
@@ -123,11 +123,11 @@
     void ConfigureAttributes();
 
   private:
-    enum Mode m_mode;             ///< store mode
-    enum FileFormat m_fileFormat; ///< store format
-    bool m_saveDeprecated;        ///< save deprecated attributes
-    std::string m_filename;       ///< store file name
-    FileConfig* m_file;           ///< configuration file
+    Mode m_mode;             ///< store mode
+    FileFormat m_fileFormat; ///< store format
+    bool m_saveDeprecated;   ///< save deprecated attributes
+    std::string m_filename;  ///< store file name
+    FileConfig* m_file;      ///< configuration file
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/model-node-creator.h ns-3.38/src/config-store/model/model-node-creator.h
--- ns-3.37/src/config-store/model/model-node-creator.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/model-node-creator.h	2023-03-16 20:54:23.584868400 -0700
@@ -36,9 +36,7 @@
 struct ModelNode
 {
     /**
-     * \enum node type
      * \brief node type structure
-     *
      */
     enum
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/model-typeid-creator.h ns-3.38/src/config-store/model/model-typeid-creator.h
--- ns-3.37/src/config-store/model/model-typeid-creator.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/model-typeid-creator.h	2023-03-16 20:54:23.584868400 -0700
@@ -38,7 +38,6 @@
 struct ModelTypeid
 {
     /**
-     * \enum node type
      * \brief Whether the node represents an attribute or TypeId
      */
     enum
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/xml-config.cc ns-3.38/src/config-store/model/xml-config.cc
--- ns-3.37/src/config-store/model/xml-config.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/xml-config.cc	2023-03-16 20:54:23.584868400 -0700
@@ -29,6 +29,7 @@
 #include "ns3/string.h"
 
 #include <libxml/encoding.h>
+#include <libxml/xmlreader.h>
 #include <libxml/xmlwriter.h>
 
 namespace ns3
@@ -46,7 +47,7 @@
 XmlConfigSave::SetFilename(std::string filename)
 {
     NS_LOG_FUNCTION(filename);
-    if (filename == "")
+    if (filename.empty())
     {
         return;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/config-store/model/xml-config.h ns-3.38/src/config-store/model/xml-config.h
--- ns-3.37/src/config-store/model/xml-config.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/config-store/model/xml-config.h	2023-03-16 20:54:23.584868400 -0700
@@ -22,10 +22,13 @@
 
 #include "file-config.h"
 
-#include <libxml/xmlreader.h>
-#include <libxml/xmlwriter.h>
 #include <string>
 
+// These are in #include <libxml/xmlwriter.h>,
+// here we just need a forward declaration.
+typedef struct _xmlTextWriter xmlTextWriter;
+typedef xmlTextWriter* xmlTextWriterPtr;
+
 namespace ns3
 {
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/CMakeLists.txt ns-3.38/src/core/CMakeLists.txt
--- ns-3.37/src/core/CMakeLists.txt	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/CMakeLists.txt	2023-03-16 20:54:23.584868400 -0700
@@ -163,12 +163,12 @@
     model/watchdog.cc
     model/synchronizer.cc
     model/make-event.cc
+    model/environment-variable.cc
     model/log.cc
     model/breakpoint.cc
     model/type-id.cc
     model/attribute-construction-list.cc
     model/object-base.cc
-    model/ref-count-base.cc
     model/object.cc
     model/test.cc
     model/random-variable-stream.cc
@@ -209,6 +209,7 @@
     model/trickle-timer.cc
     model/realtime-simulator-impl.cc
     model/wall-clock-synchronizer.cc
+    model/matrix-array.cc
 )
 
 # Define core lib headers
@@ -246,6 +247,7 @@
     model/fatal-error.h
     model/fatal-impl.h
     model/fd-reader.h
+    model/environment-variable.h
     model/global-value.h
     model/hash-fnv.h
     model/hash-function.h
@@ -278,7 +280,6 @@
     model/priority-queue-scheduler.h
     model/ptr.h
     model/random-variable-stream.h
-    model/ref-count-base.h
     model/rng-seed-manager.h
     model/rng-stream.h
     model/scheduler.h
@@ -309,9 +310,12 @@
     model/unused.h
     model/valgrind.h
     model/vector.h
+    model/warnings.h
     model/watchdog.h
     model/realtime-simulator-impl.h
     model/wall-clock-synchronizer.h
+    model/val-array.h
+    model/matrix-array.h
 )
 
 set(test_sources
@@ -323,6 +327,7 @@
     test/callback-test-suite.cc
     test/command-line-test-suite.cc
     test/config-test-suite.cc
+    test/environment-variable-test-suite.cc
     test/event-garbage-collector-test-suite.cc
     test/global-value-test-suite.cc
     test/hash-test-suite.cc
@@ -336,6 +341,7 @@
     test/ptr-test-suite.cc
     test/sample-test-suite.cc
     test/simulator-test-suite.cc
+    test/splitstring-test-suite.cc
     test/threaded-test-suite.cc
     test/time-test-suite.cc
     test/timer-test-suite.cc
@@ -345,6 +351,8 @@
     test/type-id-test-suite.cc
     test/type-traits-test-suite.cc
     test/watchdog-test-suite.cc
+    test/val-array-test-suite.cc
+    test/matrix-array-test-suite.cc
 )
 
 # Build core lib
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/doc/core.h ns-3.38/src/core/doc/core.h
--- ns-3.37/src/core/doc/core.h	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/doc/core.h	2023-03-16 20:54:23.584868400 -0700
@@ -81,3 +81,19 @@
  * \defgroup core-tests Core module tests
  * TestSuites for the Core module
  */
+
+/**
+ * \ingroup core
+ * \defgroup system System Services
+ *
+ * System-independent interfaces to operating system services:
+ * environment variables, files system, threading, wall clock time.
+ *
+ * Services provided:
+ *
+ *   - Environment variables
+ *   - File and directory paths.
+ *   - Thread primitives:  threads, conditional waits, mutex, critical sections.
+ *   - Asynchronous input from a file descriptor.
+ *   - Wall clock time.
+ */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/doc/environment-variables.h ns-3.38/src/core/doc/environment-variables.h
--- ns-3.37/src/core/doc/environment-variables.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/doc/environment-variables.h	2023-03-16 20:54:23.584868400 -0700
@@ -0,0 +1,189 @@
+/*
+ * Copyright (c) 2022 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+// This file supplies Doxygen documentation only.
+// It should *NOT* be included in the build.
+
+/**
+ * \ingroup system
+ * \defgroup core-environ Environment Variables
+ */
+
+/**
+ * \ingroup core-environ
+ * \brief Initialize an ns3::Attribute
+ *
+ * Sets a new default \pname{value} for an Attribute.
+ * This is invoked if the ns3::Object being constructed has an Attribute
+ * matching \pname{name}, and that Attribute didn't appear in the
+ * ns3::AttributeConstructionList argument to ns3::ObjectBase::ConstructSelf.
+ * The ns3::AttributeConstructionList is typically createad by an ns3::ObjectFactory
+ * and populated by ns3::ObjectFactory::Set.
+ *
+ * All objects with an Attribute matching \pname{name} will be matched,
+ * so name collisions could wreak havoc.
+ *
+ * <dl class="params">
+ *   <dt>%Parameters</dt>
+ *     <dd>
+ *       <table class="params">
+ *         <tr>
+ *           <td class="paramname">name</td>
+ *           <td>The name of the Attribute to set.</td>
+ *         </tr>
+ *         <tr>
+ *           <td class="paramname">value</td>
+ *           <td>The value to set the Attribute to.</td>
+ *         </tr>
+ *         <tr>
+ *           <td class="paramname">;</td>
+ *           <td>Multiple \pname{name}=\pname{value} pairs should be delimited by ';'</td>
+ *         </tr>
+ *       </table>
+ *     </dd>
+ * </dl>
+ *
+ * Referenced by ns3::ObjectBase::ConstructSelf.
+ */
+const char* NS_ATTRIBUTE_DEFAULT = "name=value[;...]";
+
+/**
+ * \ingroup core-environ
+ * \brief Write the ns3::CommandLine::Usage message, in Doxygen format,
+ * to the referenced location.
+ *
+ * Set the directory where ns3::CommandLine instances should write their Usage
+ * message, used when building documentation.
+ *
+ * This is used primarily by the documentation builds, which execute each
+ * registered example to gather their ns3::CommandLine::Usage information.
+ * This wouldn't normally be useful to users.
+ *
+ * <dl class="params">
+ *   <dt>%Parameters</dt>
+ *   <dd>
+ *     <table class="params">
+ *       <tr>
+ *         <td class="paramname">path</td>
+ *         <td> The directory where ns3::CommandLine should write its Usage message.</td>
+ *       </tr>
+ *     </table>
+ *   </dd>
+ * </dl>
+ *
+ * Referenced by ns3::CommandLine::PrintDoxygenUsage.
+ */
+const char* NS_COMMANDLINE_INTROSPECTION = "path";
+
+/**
+ * \ingroup core-environ
+ * \brief Initialize a ns3::GlobalValue.
+ *
+ * Initialize the ns3::GlobalValue \pname{name} from \pname{value}.
+ *
+ * This overrides the initial value set in the corresponding
+ * ns3::GlobalValue constructor.
+ *
+ * <dl class="params">
+ *   <dt>%Parameters</dt>
+ *   <dd>
+ *     <table class="params">
+ *       <tr>
+ *         <td class="paramname">name</td>
+ *         <td>The name of the ns3::GlobalValue to set.</td>
+ *       </tr>
+ *       <tr>
+ *         <td class="paramname">value</td>
+ *         <td>The value to set the ns3::GlobalValue to.</td>
+ *       </tr>
+ *       <tr>
+ *         <td class="paramname">;</td>
+ *         <td>Multiple \pname{name}=\pname{value} pairs should be delimited by ';'</td>
+ *       </tr>
+ *     </table>
+ *   </dd>
+ * </dl>
+ *
+ * Referenced by ns3::GlobalValue::InitializeFromEnv.
+ */
+const char* NS_GLOBAL_VALUE = "name=value[;...]";
+
+/**
+ * \ingroup core-environ
+ * \brief Control which logging components are enabled.
+ *
+ * Enable logging from specific \pname{component}s, with specified \pname{option}s.
+ * See the \ref logging module, or the Logging chapter
+ * in the manual for details on what symbols can be used for specifying
+ * log level and prefix options.
+ *
+ * <dl class="params">
+ *   <dt>%Parameters</dt>
+ *   <dd>
+ *     <table class="params">
+ *       <tr>
+ *         <td class="paramname">component</td>
+ *         <td>The logging component to enable.</td>
+ *       </tr>
+ *       <tr>
+ *         <td class="paramname">option</td>
+ *         <td>Log level and or prefix to enable. Multiple options should be delimited with '|'</td>
+ *       </tr>
+ *       <tr>
+ *         <td class="paramname">:</td>
+ *         <td>Multiple logging components can be enabled simultaneously, delimited by ':'</td>
+ *       </tr>
+ *     </table>
+ *   </dd>
+ * </dl>
+ *
+ * Referenced by ns3::PrintList, ns3::LogComponent::EnvVarCheck and
+ * ns3::CheckEnvironmentVariables(), all in \ref log.cc.
+ */
+const char* NS_LOG = "component=option[|option...][:...]";
+
+/**
+ * \ingroup core-environ
+ * \brief Where to make temporary directories.
+ *
+ * The absolute path where ns-3 should make temporary directories.
+ *
+ * See ns3::SystemPath::MakeTemporaryDirectoryName for details on how this environment
+ * variable is used to create a temporary directory, and how that directory
+ * will be named.
+ *
+ * <dl class="params">
+ *   <dt>%Parameters</dt>
+ *   <dd>
+ *     <table class="params">
+ *       <tr>
+ *         <td class="paramname">path</td>
+ *         <td>The absolute path in which to create the temporary directory.</td>
+ *       </tr>
+ *     </table>
+ *   </dd>
+ * </dl>
+ *
+ * Referenced by ns3::SystemPath::MakeTemporaryDirectoryName.
+ *
+ * @{
+ */
+const char* TMP = "path";
+const char* TEMP = "path";
+/**@}*/
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/assert-example.cc ns-3.38/src/core/examples/assert-example.cc
--- ns-3.37/src/core/examples/assert-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/core/examples/assert-example.cc	2023-03-16 20:54:23.584868400 -0700
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2023 Lawrence Livermore National Laboratory
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Peter D. Barnes, Jr. <pdbarnes@llnl.gov>
+ */
+
+/**
+ * \file
+ * \ingroup core-examples
+ * \ingroup assert
+ * Example program illustrating the use of NS_ASSERT_MSG()
+ */
+
+#include "ns3/core-module.h"
+
+#include <iostream>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE("AssertExample");
+
+int
+main(int argc, char** argv)
+{
+    CommandLine cmd;
+    cmd.Parse(argc, argv);
+
+    std::cout << "NS_ASSERT_MSG example\n"
+              << "  if an argument is given this example will assert.\n";
+
+    NS_ASSERT_MSG(argc == 1, "An argument was given, so we assert");
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/CMakeLists.txt ns-3.38/src/core/examples/CMakeLists.txt
--- ns-3.37/src/core/examples/CMakeLists.txt	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/examples/CMakeLists.txt	2023-03-16 20:54:23.584868400 -0700
@@ -1,4 +1,5 @@
 set(base_examples
+    assert-example
     command-line-example
     fatal-example
     hash-example
@@ -55,3 +56,10 @@
   LIBRARIES_TO_LINK ${libcore}
                     ${libflow-monitor}
 )
+
+build_lib_example(
+  NAME log-example
+  SOURCE_FILES log-example.cc
+  LIBRARIES_TO_LINK ${libcore}
+                    ${libnetwork}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/command-line-example.cc ns-3.38/src/core/examples/command-line-example.cc
--- ns-3.37/src/core/examples/command-line-example.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/examples/command-line-example.cc	2023-03-16 20:54:23.584868400 -0700
@@ -49,7 +49,7 @@
  * \returns \c true.
  */
 bool
-SetCbArg(std::string val)
+SetCbArg(const std::string& val)
 {
     g_cbArg = val;
     return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/empirical-random-variable-example.cc ns-3.38/src/core/examples/empirical-random-variable-example.cc
--- ns-3.37/src/core/examples/empirical-random-variable-example.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/examples/empirical-random-variable-example.cc	2023-03-16 20:54:23.584868400 -0700
@@ -82,13 +82,16 @@
  * \param value The value to print.
  * \param count The number of times that value has been sampled.
  * \param n The total number of random values sampled.
+ * \param sum The sum of the counts seen up to \p value, used to show
+ *            the CDF for \p value.
  */
 void
-PrintStatsLine(const double value, const long count, const long n)
+PrintStatsLine(const double value, const long count, const long n, const long sum)
 {
     std::cout << std::fixed << std::setprecision(3) << std::setw(10) << std::right << value
               << std::setw(10) << std::right << count << std::setw(10) << std::right
-              << count / static_cast<double>(n) * 100.0 << std::endl;
+              << count / static_cast<double>(n) * 100.0 << std::setw(10) << std::right
+              << sum / static_cast<double>(n) * 100.0 << std::endl;
 }
 
 /**
@@ -136,21 +139,21 @@
     long sum = 0;
     double weighted = 0;
     std::cout << std::endl;
-    std::cout << "     Value    Counts         %" << std::endl;
-    std::cout << "----------  --------  --------" << std::endl;
+    std::cout << "     Value    Counts         %     % CDF" << std::endl;
+    std::cout << "----------  --------  --------  --------" << std::endl;
     for (auto c : counts)
     {
         long count = c.second;
         double value = c.first;
         sum += count;
         weighted += value * count;
-        PrintStatsLine(value, count, n);
+        PrintStatsLine(value, count, n, sum);
     }
-    PrintSummary(sum, n, weighted, 8.75);
+    PrintSummary(sum, n, weighted, 0.8);
 
     std::cout << "Interpolating " << mode << std::endl;
     erv->SetInterpolate(true);
-    Histogram h(0.5);
+    Histogram h(0.1);
     for (long i = 0; i < n; ++i)
     {
         h.AddValue(erv->GetValue());
@@ -161,8 +164,8 @@
     sum = 0;
     weighted = 0;
     std::cout << std::endl;
-    std::cout << " Bin Start    Counts         %" << std::endl;
-    std::cout << "----------  --------  --------" << std::endl;
+    std::cout << " Bin Start    Counts         %     % CDF" << std::endl;
+    std::cout << "----------  --------  --------  --------" << std::endl;
     for (uint32_t i = 0; i < h.GetNBins(); ++i)
     {
         long count = h.GetBinCount(i);
@@ -170,9 +173,9 @@
         double value = start + h.GetBinWidth(i) / 2.;
         sum += count;
         weighted += count * value;
-        PrintStatsLine(start, count, n);
+        PrintStatsLine(start, count, n, sum);
     }
-    PrintSummary(sum, n, weighted, 6.25);
+    PrintSummary(sum, n, weighted, 0.760);
 }
 
 int
@@ -203,10 +206,15 @@
 
     // Create the ERV in sampling mode
     Ptr<EmpiricalRandomVariable> erv = CreateObject<EmpiricalRandomVariable>();
-    erv->SetInterpolate(false);
-    erv->CDF(0.0, 0.0);
-    erv->CDF(5.0, 0.25);
-    erv->CDF(10.0, 1.0);
+
+    //                          // Expectation for bin
+    erv->CDF(0.0, 0.0 / 15.0);  // 0
+    erv->CDF(0.2, 1.0 / 15.0);  // 0.2 1/15  =  2/150
+    erv->CDF(0.4, 3.0 / 15.0);  // 0.4 2/15  =  8/150
+    erv->CDF(0.6, 4.0 / 15.0);  // 0.6 1/15  =  6/150
+    erv->CDF(0.8, 7.0 / 15.0);  // 0.8 3/15  = 24/150
+    erv->CDF(1.0, 9.0 / 15.0);  // 1.0 2/15  = 20/150
+    erv->CDF(1.0, 15.0 / 15.0); // 1.0 6/15  = 60/150  <avg> = 120/150 = 0.8
 
     if (single)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/hash-example.cc ns-3.38/src/core/examples/hash-example.cc
--- ns-3.37/src/core/examples/hash-example.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/examples/hash-example.cc	2023-03-16 20:54:23.584868400 -0700
@@ -137,7 +137,7 @@
      * \param [in] hash Hash function.
      * \param [in] bits Which hash length to use.
      */
-    Collider(const std::string name, Hasher hash, const enum Bits bits)
+    Collider(const std::string name, Hasher hash, const Bits bits)
         : m_name(name),
           m_hash(hash),
           m_bits(bits)
@@ -245,7 +245,7 @@
     }
 
     /** Hash function. */
-    enum Bits m_bits;
+    Bits m_bits;
 
     /** Hashed dictionary of first instance of each hash. */
     typedef std::map<uint64_t, std::string> hashdict_t;
@@ -291,7 +291,7 @@
      */
     void Add(const std::string phrase)
     {
-        if (phrase.size() == 0)
+        if (phrase.empty())
         {
             return;
         }
@@ -437,7 +437,7 @@
      * \param [in] file The word file to add.
      * \return \c true If the file is new to the list.
      */
-    bool Add(const std::string file)
+    bool Add(const std::string& file)
     {
         if (std::find(m_files.begin(), m_files.end(), file) == m_files.end())
         {
@@ -460,7 +460,7 @@
      */
     void ReadInto(Dictionary& dict)
     {
-        if (m_files.size() == 0)
+        if (m_files.empty())
         {
             Add(GetDefault());
         }
@@ -545,4 +545,5 @@
         dict.Time();
     } // if (timing)
 
+    return 0;
 } // main
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/core/examples/length-example.cc ns-3.38/src/core/examples/length-example.cc
--- ns-3.37/src/core/examples/length-example.cc	2022-11-01 17:37:24.463395000 -0700
+++ ns-3.38/src/core/examples/length-example.cc	2023-03-16 20:54:23.584868400 -0700
@@ -23,17 +23,21 @@
 #include <iostream>
 
 /**
- * \file
+ * \defgroup length-examples Demonstrates usage of the ns3::Length class
  * \ingroup core-examples
  * \ingroup length
+ */
+
+/**
+ * \file
+ * \ingroup length-examples
  * Demonstrates usage of the ns3::Length class
  */
 
 using namespace ns3;
 
 /**
- * \ingroup core-examples
- * \ingroup length
+ * \ingroup length-examples
  * \brief Demonstrates the use of ns3::Length constructors.
  */
 void
@@ -55,8 +59,7 @@
 }
 
 /**
- * \ingroup core-examples
- * \ingroup length
+ * \ingroup length-examples
  * \brief Demonstrates the use of ns3::Length conversions.
  */
 void
@@ -75,8 +78,7 @@
 }
 
 /**
- * \ingroup core-examples
- * \ingroup length
+ * \ingroup length-examples
  * \brief Demonstrates the use of ns3::Length arithmetic operators.
  */
 void
@@ -103,8 +105,7 @@
 }
 
 /**
- * \ingroup core-examples
- * \ingroup length
+ * \ingroup length-examples
  * \brief Demonstrates the use of ns3::Length equality operators.
  */
 void
@@ -141,8 +142,7 @@
 }
 
 /**
- * \ingroup core-examples
- * \ingroup length
+ * \ingroup length-examples
  * \brief Demonstrates the use of ns3::Length multiplications and divisions.
  */
 void
